{  Inquisition Sound Server for Free Pascal  }
{  By Charlie/Inquisition                    }

{  Timer - Timer API Example Program         }
{  Coding Starts     : 13. October. 1998.    }
{  Last Modification : 29. March. 2000.      }
Program Timer;

Uses CRT,DOS,GO32,ISS_Tim;

Const TimerExmpleVer : PChar = '1.0.0';

Var TimerCounter1 : DWord; {  First Counter  }
    TimerCounter2 : DWord; {  Second Counter  }
    TimerProc     : Pointer;
    Hours, Minutes, Seconds, Sec100: Word;

{  First Timer Procedure  }
Procedure Timer1;
Begin
 Inc(TimerCounter1);
End;
Procedure Timer1_Dummy; Begin End;

{  Second Timer Procedure  }
Procedure Timer2;
Begin
 Inc(TimerCounter2);
End;
Procedure Timer2_Dummy; Begin End;

Begin

 {  INITIALIZATION BEGINS  }
 WriteLn;
 WriteLn(' ISS Timer Services API Example Program ',TimerExmpleVer);
 WriteLn(' By Charlie/Inquisition ');
 WriteLn;

 {  Must lock all code and data used by timer routine!!!  }
 Lock_Data(TimerCounter1,SizeOf(TimerCounter1));
 Lock_Code(@Timer1,LongInt(@Timer1_Dummy)-LongInt(@Timer1));
 TimerProc:=@Timer1;
 If Not ISS_StartTimer(TimerProc,(ISS_TimerSpeed Div 70)) Then
    WriteLn(' ERROR : CANNOT START 70HZ TIMER!');
 {  Must lock all code and data used by timer routine!!!  }
 Lock_Data(TimerCounter2,SizeOf(TimerCounter2));
 Lock_Code(@Timer2,LongInt(@Timer2_Dummy)-LongInt(@Timer2));
 TimerProc:=@Timer2;
 If Not ISS_StartTimer(TimerProc,(ISS_TimerSpeed Div 50)) Then
    WriteLn(' ERROR : CANNOT START 50HZ TIMER!');

 WriteLn;
 {  INITIALIZATION ENDS  }

 {  MAIN  }
 Repeat
  WriteLn(' First (70HZ) Timer  - ',TimerCounter1,' Ticks');
  WriteLn(' Second (50HZ) Timer - ',TimerCounter2,' Ticks');
  GetTime(Hours, Minutes, Seconds, Sec100);
  WriteLn;
  WriteLn(' BIOS (18.2HZ) Timer - ',Hours,':',Minutes,':',Seconds,',',Sec100,'    ');
  WriteLn;
  GotoXY(1,WhereY-5);
  Delay(20);
 Until KeyPressed;
 {  MAIN  }

 {  SHUTDOWN  }
 GotoXY(1,WhereY+5);

 TimerProc:=@Timer1;
 If Not ISS_StopTimer(TimerProc) Then
    WriteLn(' ERROR : CANNOT STOP 70HZ TIMER!');
 Unlock_Data(TimerCounter1,SizeOf(TimerCounter1));
 Unlock_Code(@Timer1,LongInt(@Timer1_Dummy)-LongInt(@Timer1));
 TimerProc:=@Timer2;
 If Not ISS_StopTimer(TimerProc) Then
    WriteLn(' ERROR : CANNOT STOP 50HZ TIMER!');
 Unlock_Data(TimerCounter2,SizeOf(TimerCounter2));
 Unlock_Code(@Timer2,LongInt(@Timer2_Dummy)-LongInt(@Timer2));

 While KeyPressed Do ReadKey;
 WriteLn; WriteLn(' Done.');
 {  SHUTDOWN  }

End.
{  Lame code. But who cares?  }
{  TIMER.PAS - (C) 1998-2000 Charlie/Inquisition  }
